#include <iostream>
#include "gammaNNLO.hh"
#include "../parameters.hh"


struct s_complex { double re; double im; };

// non-singlet
extern "C" {
  void p2nsp_( s_complex *p2plsn,
	       s_complex *p2minn,
	       s_complex *p2valn,
	       s_complex *N,
	       int *nf );
}
void p2nsp(dcomplex &p2plsn, dcomplex &p2minn, dcomplex &p2valn, dcomplex N, int nf) {
  s_complex sp2plsn, sp2minn, sp2valn, sN = {real(N), imag(N)};
  p2nsp_(&sp2plsn, &sp2minn, &sp2valn, &sN, &nf);
  p2plsn = dcomplex(sp2plsn.re, sp2plsn.im);
  p2minn = dcomplex(sp2minn.re, sp2minn.im);
  p2valn = dcomplex(sp2valn.re, sp2valn.im);
  return;
}
dcomplex gamma2NSplus(dcomplex N, int nf) {
  dcomplex plus, minus, val;
  p2nsp(plus, minus, val, N, nf);
  return plus /fourPi3;
}
dcomplex gamma2NSminus(dcomplex N, int nf) {
  dcomplex plus, minus, val;
  p2nsp(plus, minus, val, N, nf);
  return minus /fourPi3;
}
dcomplex gamma2NSval(dcomplex N, int nf) {
  dcomplex plus, minus, val;
  p2nsp(plus, minus, val, N, nf);
  return val /fourPi3;
}




// singlet
extern "C" {
  void p2ijp_( s_complex *p2psn,
	       s_complex *p2qgn,
	       s_complex *p2gqn,
	       s_complex *p2ggn,
	       s_complex *N,
	       int *nf );
}
void p2ijp(dcomplex &p2psn, dcomplex &p2qgn, dcomplex &p2gqn, dcomplex &p2ggn, dcomplex N, int nf) {
  s_complex sp2psn, sp2qgn, sp2gqn, sp2ggn, sN = {real(N), imag(N)};
  p2ijp_(&sp2psn, &sp2qgn, &sp2gqn, &sp2ggn, &sN, &nf);
  p2psn = dcomplex(sp2psn.re, sp2psn.im);
  p2qgn = dcomplex(sp2qgn.re, sp2qgn.im);
  p2gqn = dcomplex(sp2gqn.re, sp2gqn.im);
  p2ggn = dcomplex(sp2ggn.re, sp2ggn.im);
  return;
}


dcomplex gamma2SGqq(dcomplex N, int nf) {
  dcomplex ps, qg, gq, gg;
  dcomplex plus = gamma2NSplus(N, nf);
  p2ijp(ps, qg, gq, gg, N, nf);
  return plus + ps/fourPi3;
}
dcomplex gamma2SGqg(dcomplex N, int nf) {
  dcomplex ps, qg, gq, gg;
  p2ijp(ps, qg, gq, gg, N, nf);
  return qg/fourPi3;
}
dcomplex gamma2SGgq(dcomplex N, int nf) {
  dcomplex ps, qg, gq, gg;
  p2ijp(ps, qg, gq, gg, N, nf);
  return gq/fourPi3;
}
dcomplex gamma2SGgg(dcomplex N, int nf) {
  dcomplex ps, qg, gq, gg;
  p2ijp(ps, qg, gq, gg, N, nf);
  return gg/fourPi3;
}
